
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"

/* Last modified by Sean Hunt, 2014-10-17 */
/*	Copyright (c) 1989 by Jean-Christophe Collet */
/* NetHack may be freely redistributed.  See license for details. */
#include "hack.h"
#include "sp_lev.h"
#include "lev_compiler.h"

/*
 * This file contains the Level Compiler code
 * It may handle special mazes & special room-levels
 */

#define MAX_REGISTERS	10
#define ERR		(-1)
/* many types of things are put in chars for transference to NetHack.
 * since some systems will use signed chars, limit everybody to the
 * same number for portability.
 */
#define MAX_OF_TYPE	128

#define New(type)		\
	(type *) memset(malloc(sizeof(type)), 0, sizeof(type))
#define NewTab(type, size)	malloc(sizeof(type *) * size)
#define Free(ptr)		free(ptr)

static struct reg {
	int x1, y1;
	int x2, y2;
}		current_region;

static struct coord {
	int x;
	int y;
}		current_coord, current_align;

static struct size {
	int height;
	int width;
}		current_size;

char tmpmessage[256];
char tmphallumsg[256];
digpos *tmppass[32];
char *tmpmap[ROWNO];

digpos *tmpdig[MAX_OF_TYPE];
region *tmpreg[MAX_OF_TYPE];
lev_region *tmplreg[MAX_OF_TYPE];
door *tmpdoor[MAX_OF_TYPE];
drawbridge *tmpdb[MAX_OF_TYPE];
walk *tmpwalk[MAX_OF_TYPE];

room_door *tmprdoor[MAX_OF_TYPE];
trap *tmptrap[MAX_OF_TYPE];
monster *tmpmonst[MAX_OF_TYPE];
object *tmpobj[MAX_OF_TYPE];
altar *tmpaltar[MAX_OF_TYPE];
lad *tmplad[MAX_OF_TYPE];
stair *tmpstair[MAX_OF_TYPE];
gold *tmpgold[MAX_OF_TYPE];
engraving *tmpengraving[MAX_OF_TYPE];
fountain *tmpfountain[MAX_OF_TYPE];
sink *tmpsink[MAX_OF_TYPE];
pool *tmppool[MAX_OF_TYPE];

mazepart *tmppart[10];
room *tmproom[MAXNROFROOMS*2];
static corridor *tmpcor[MAX_OF_TYPE];

static specialmaze maze;
static splev special_lev;
static lev_init init_lev;

static char olist[MAX_REGISTERS], mlist[MAX_REGISTERS];
static struct coord plist[MAX_REGISTERS];

int n_olist = 0, n_mlist = 0, n_plist = 0;

unsigned int nlreg = 0, nreg = 0, ndoor = 0, ntrap = 0, nmons = 0, nobj = 0;
unsigned int ndb = 0, nwalk = 0, npart = 0, ndig = 0, nlad = 0, nstair = 0;
unsigned int naltar = 0, ncorridor = 0, nrooms = 0, ngold = 0, nengraving = 0;
unsigned int nfountain = 0, npool = 0, nsink = 0, npass = 0;

static int lev_flags = 0;

unsigned int max_x_map, max_y_map;

static xchar in_room;

#ifdef __clang__
# pragma clang diagnostic ignored "-Wmissing-variable-declarations"
#endif



/* Line 189 of yacc.c  */
#line 170 "/home/nathan/git/working-fourk/build/libnethack/util/lev_comp.y/lev_comp.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     CHAR = 258,
     INTEGER = 259,
     BOOLEAN = 260,
     PERCENT = 261,
     MESSAGE_ID = 262,
     HALLUMSG_ID = 263,
     MAZE_ID = 264,
     LEVEL_ID = 265,
     LEV_INIT_ID = 266,
     GEOMETRY_ID = 267,
     NOMAP_ID = 268,
     OBJECT_ID = 269,
     COBJECT_ID = 270,
     MONSTER_ID = 271,
     TRAP_ID = 272,
     DOOR_ID = 273,
     DRAWBRIDGE_ID = 274,
     MAZEWALK_ID = 275,
     WALLIFY_ID = 276,
     REGION_ID = 277,
     FILLING = 278,
     RANDOM_OBJECTS_ID = 279,
     RANDOM_MONSTERS_ID = 280,
     RANDOM_PLACES_ID = 281,
     ALTAR_ID = 282,
     LADDER_ID = 283,
     STAIR_ID = 284,
     NON_DIGGABLE_ID = 285,
     NON_PASSWALL_ID = 286,
     ROOM_ID = 287,
     PORTAL_ID = 288,
     TELEPRT_ID = 289,
     BRANCH_ID = 290,
     LEV = 291,
     CHANCE_ID = 292,
     CORRIDOR_ID = 293,
     GOLD_ID = 294,
     ENGRAVING_ID = 295,
     FOUNTAIN_ID = 296,
     POOL_ID = 297,
     SINK_ID = 298,
     NONE = 299,
     RAND_CORRIDOR_ID = 300,
     DOOR_STATE = 301,
     LIGHT_STATE = 302,
     CURSE_TYPE = 303,
     ENGRAVING_TYPE = 304,
     DIRECTION = 305,
     RANDOM_TYPE = 306,
     O_REGISTER = 307,
     M_REGISTER = 308,
     P_REGISTER = 309,
     A_REGISTER = 310,
     ALIGNMENT = 311,
     LEFT_OR_RIGHT = 312,
     CENTER = 313,
     TOP_OR_BOT = 314,
     ALTAR_TYPE = 315,
     UP_OR_DOWN = 316,
     SUBROOM_ID = 317,
     NAME_ID = 318,
     FLAGS_ID = 319,
     FLAG_TYPE = 320,
     MON_ATTITUDE = 321,
     MON_ALERTNESS = 322,
     MON_APPEARANCE = 323,
     CONTAINED = 324,
     STRING = 325,
     MAP_ID = 326
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 98 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"

	int	i;
	char*	map;
	struct {
		signed char room;
		signed char wall;
		signed char door;
	} corpos;



/* Line 214 of yacc.c  */
#line 289 "/home/nathan/git/working-fourk/build/libnethack/util/lev_comp.y/lev_comp.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 301 "/home/nathan/git/working-fourk/build/libnethack/util/lev_comp.y/lev_comp.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  12
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   454

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  78
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  121
/* YYNRULES -- Number of rules.  */
#define YYNRULES  228
/* YYNRULES -- Number of states.  */
#define YYNSTATES  485

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   326

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      72,    73,     2,     2,    70,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    71,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    74,     2,    75,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    76,    77
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    13,    15,    22,
      30,    34,    35,    49,    65,    67,    69,    70,    74,    78,
      80,    81,    84,    88,    89,    92,    96,    97,   100,   104,
     108,   109,   111,   113,   116,   118,   120,   122,   123,   126,
     132,   138,   146,   149,   152,   165,   178,   179,   182,   188,
     190,   196,   198,   204,   206,   212,   214,   215,   218,   220,
     222,   224,   226,   228,   230,   232,   234,   236,   238,   240,
     242,   244,   248,   252,   262,   264,   266,   268,   270,   272,
     274,   280,   282,   284,   286,   289,   293,   295,   298,   304,
     306,   308,   310,   312,   313,   316,   320,   324,   328,   330,
     334,   336,   340,   342,   343,   348,   349,   352,   354,   356,
     358,   360,   362,   364,   366,   368,   370,   372,   374,   376,
     378,   380,   382,   384,   386,   388,   390,   392,   393,   404,
     405,   408,   411,   414,   417,   420,   424,   427,   430,   431,
     441,   443,   445,   446,   454,   460,   466,   468,   470,   472,
     474,   476,   477,   480,   483,   489,   496,   504,   510,   512,
     518,   524,   525,   534,   535,   544,   545,   546,   555,   556,
     563,   564,   567,   569,   580,   584,   588,   592,   596,   600,
     604,   613,   621,   627,   635,   637,   639,   641,   643,   645,
     647,   649,   651,   653,   655,   657,   659,   661,   663,   664,
     667,   672,   674,   676,   678,   680,   682,   684,   686,   688,
     690,   692,   694,   696,   701,   706,   711,   716,   718,   720,
     722,   724,   726,   728,   729,   731,   733,   735,   741
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      79,     0,    -1,    -1,    80,    -1,    81,    -1,    81,    80,
      -1,    82,    -1,    83,    -1,   118,    87,    85,    89,    91,
     120,    -1,    84,    87,    85,    89,    93,    95,    97,    -1,
      10,    71,   193,    -1,    -1,    11,    71,     3,    70,     3,
      70,     5,    70,     5,    70,   183,    70,    86,    -1,    11,
      71,     3,    70,     3,    70,     5,    70,     5,    70,   183,
      70,    86,    70,     5,    -1,     5,    -1,    51,    -1,    -1,
      64,    71,    88,    -1,    65,    70,    88,    -1,    65,    -1,
      -1,    90,    89,    -1,     7,    71,    76,    -1,    -1,    92,
      91,    -1,     8,    71,    76,    -1,    -1,    93,    94,    -1,
      24,    71,   128,    -1,    25,    71,   129,    -1,    -1,    96,
      -1,   102,    -1,   102,    96,    -1,    98,    -1,    99,    -1,
      45,    -1,    -1,    99,   100,    -1,    38,    71,   101,    70,
     101,    -1,    38,    71,   101,    70,     4,    -1,    72,     4,
      70,    50,    70,   117,    73,    -1,   104,   110,    -1,   103,
     110,    -1,    62,    71,   179,    70,   183,    70,   107,    70,
     109,    70,   193,   105,    -1,    32,    71,   179,    70,   183,
      70,   106,    70,   108,    70,   109,   105,    -1,    -1,    70,
       5,    -1,    72,     4,    70,     4,    73,    -1,    51,    -1,
      72,     4,    70,     4,    73,    -1,    51,    -1,    72,   124,
      70,   125,    73,    -1,    51,    -1,    72,     4,    70,     4,
      73,    -1,    51,    -1,    -1,   110,   111,    -1,   112,    -1,
     113,    -1,   114,    -1,   134,    -1,   138,    -1,   148,    -1,
     171,    -1,   165,    -1,   166,    -1,   167,    -1,   172,    -1,
     173,    -1,   153,    -1,    63,    71,   193,    -1,    37,    71,
       4,    -1,    18,    71,   115,    70,   182,    70,   116,    70,
     117,    -1,     5,    -1,    51,    -1,    50,    -1,    51,    -1,
       4,    -1,    51,    -1,     9,    71,   193,    70,   119,    -1,
       3,    -1,    51,    -1,   121,    -1,   121,   120,    -1,   122,
     126,   132,    -1,    13,    -1,   123,    77,    -1,    12,    71,
     124,    70,   125,    -1,    57,    -1,    58,    -1,    59,    -1,
      58,    -1,    -1,   126,   127,    -1,    24,    71,   128,    -1,
      26,    71,   130,    -1,    25,    71,   129,    -1,   192,    -1,
     192,    70,   128,    -1,   191,    -1,   191,    70,   129,    -1,
     190,    -1,    -1,   190,   131,    70,   130,    -1,    -1,   132,
     133,    -1,   134,    -1,   138,    -1,   147,    -1,   148,    -1,
     149,    -1,   170,    -1,   154,    -1,   156,    -1,   158,    -1,
     161,    -1,   171,    -1,   165,    -1,   150,    -1,   151,    -1,
     152,    -1,   153,    -1,   172,    -1,   173,    -1,   168,    -1,
     169,    -1,    -1,    16,   195,    71,   174,    70,   176,    70,
     181,   135,   136,    -1,    -1,   136,   137,    -1,    70,   193,
      -1,    70,    66,    -1,    70,    67,    -1,    70,   184,    -1,
      70,    68,   193,    -1,    14,   139,    -1,    15,   139,    -1,
      -1,   195,    71,   175,    70,   177,   140,    70,   141,   142,
      -1,   181,    -1,    69,    -1,    -1,    70,   143,    70,   144,
      70,   145,   146,    -1,    70,   143,    70,   145,   146,    -1,
      70,   144,    70,   145,   146,    -1,    51,    -1,    48,    -1,
      76,    -1,    51,    -1,     4,    -1,    -1,    70,    44,    -1,
      70,    76,    -1,    18,    71,   182,    70,   181,    -1,    17,
     195,    71,   178,    70,   181,    -1,    19,    71,   181,    70,
      50,    70,   182,    -1,    20,    71,   181,    70,    50,    -1,
      21,    -1,    28,    71,   181,    70,    61,    -1,    29,    71,
     181,    70,    61,    -1,    -1,    29,    71,   164,   155,    70,
     164,    70,    61,    -1,    -1,    33,    71,   164,   157,    70,
     164,    70,   193,    -1,    -1,    -1,    34,    71,   164,   159,
      70,   164,   160,   163,    -1,    -1,    35,    71,   164,   162,
      70,   164,    -1,    -1,    70,    61,    -1,   198,    -1,    36,
      72,     4,    70,     4,    70,     4,    70,     4,    73,    -1,
      36,    72,    73,    -1,    41,    71,   181,    -1,    43,    71,
     181,    -1,    42,    71,   181,    -1,    30,    71,   198,    -1,
      31,    71,   198,    -1,    22,    71,   198,    70,   183,    70,
     179,   180,    -1,    27,    71,   181,    70,   184,    70,   185,
      -1,    39,    71,   194,    70,   181,    -1,    40,    71,   181,
      70,   196,    70,   193,    -1,   191,    -1,    51,    -1,   188,
      -1,   192,    -1,    51,    -1,   187,    -1,   193,    -1,    51,
      -1,   193,    -1,    51,    -1,   193,    -1,    51,    -1,   193,
      -1,    51,    -1,    -1,    70,    23,    -1,    70,    23,    70,
       5,    -1,   197,    -1,   186,    -1,    51,    -1,    46,    -1,
      51,    -1,    47,    -1,    51,    -1,    56,    -1,   189,    -1,
      51,    -1,    60,    -1,    51,    -1,    54,    74,     4,    75,
      -1,    52,    74,     4,    75,    -1,    53,    74,     4,    75,
      -1,    55,    74,     4,    75,    -1,   197,    -1,     3,    -1,
       3,    -1,    76,    -1,     4,    -1,    51,    -1,    -1,     6,
      -1,    49,    -1,    51,    -1,    72,     4,    70,     4,    73,
      -1,    72,     4,    70,     4,    70,     4,    70,     4,    73,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   136,   136,   137,   140,   141,   144,   145,   148,   175,
     212,   225,   233,   252,   274,   275,   279,   282,   289,   293,
     299,   300,   303,   320,   321,   324,   342,   343,   346,   357,
     371,   385,   388,   389,   392,   393,   396,   404,   405,   408,
     423,   439,   449,   453,   459,   477,   496,   499,   505,   515,
     521,   530,   536,   541,   547,   552,   558,   559,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   577,   586,   599,   619,   620,   623,   624,   627,   628,
     631,   644,   648,   654,   655,   658,   664,   680,   693,   699,
     700,   703,   704,   707,   708,   711,   722,   737,   750,   757,
     766,   773,   782,   790,   789,   799,   800,   803,   804,   805,
     806,   807,   808,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   820,   821,   822,   826,   825,   861,
     862,   865,   869,   873,   877,   881,   888,   891,   901,   900,
     928,   937,   947,   956,   959,   962,   967,   971,   977,   988,
     992,   998,   999,  1002,  1008,  1026,  1043,  1085,  1099,  1105,
    1122,  1140,  1139,  1169,  1168,  1195,  1204,  1194,  1228,  1227,
    1254,  1257,  1263,  1267,  1285,  1293,  1309,  1322,  1335,  1350,
    1365,  1431,  1449,  1466,  1484,  1485,  1489,  1492,  1493,  1497,
    1500,  1501,  1507,  1508,  1514,  1522,  1525,  1535,  1539,  1542,
    1546,  1552,  1553,  1554,  1560,  1561,  1564,  1565,  1568,  1569,
    1570,  1576,  1577,  1580,  1589,  1598,  1607,  1616,  1619,  1630,
    1642,  1645,  1646,  1650,  1653,  1661,  1662,  1665,  1676
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CHAR", "INTEGER", "BOOLEAN", "PERCENT",
  "MESSAGE_ID", "HALLUMSG_ID", "MAZE_ID", "LEVEL_ID", "LEV_INIT_ID",
  "GEOMETRY_ID", "NOMAP_ID", "OBJECT_ID", "COBJECT_ID", "MONSTER_ID",
  "TRAP_ID", "DOOR_ID", "DRAWBRIDGE_ID", "MAZEWALK_ID", "WALLIFY_ID",
  "REGION_ID", "FILLING", "RANDOM_OBJECTS_ID", "RANDOM_MONSTERS_ID",
  "RANDOM_PLACES_ID", "ALTAR_ID", "LADDER_ID", "STAIR_ID",
  "NON_DIGGABLE_ID", "NON_PASSWALL_ID", "ROOM_ID", "PORTAL_ID",
  "TELEPRT_ID", "BRANCH_ID", "LEV", "CHANCE_ID", "CORRIDOR_ID", "GOLD_ID",
  "ENGRAVING_ID", "FOUNTAIN_ID", "POOL_ID", "SINK_ID", "NONE",
  "RAND_CORRIDOR_ID", "DOOR_STATE", "LIGHT_STATE", "CURSE_TYPE",
  "ENGRAVING_TYPE", "DIRECTION", "RANDOM_TYPE", "O_REGISTER", "M_REGISTER",
  "P_REGISTER", "A_REGISTER", "ALIGNMENT", "LEFT_OR_RIGHT", "CENTER",
  "TOP_OR_BOT", "ALTAR_TYPE", "UP_OR_DOWN", "SUBROOM_ID", "NAME_ID",
  "FLAGS_ID", "FLAG_TYPE", "MON_ATTITUDE", "MON_ALERTNESS",
  "MON_APPEARANCE", "CONTAINED", "','", "':'", "'('", "')'", "'['", "']'",
  "STRING", "MAP_ID", "$accept", "file", "levels", "level", "maze_level",
  "room_level", "level_def", "lev_init", "walled", "flags", "flag_list",
  "messages", "message", "hallumsgs", "hallumsg", "rreg_init", "init_rreg",
  "rooms", "roomlist", "corridors_def", "random_corridors", "corridors",
  "corridor", "corr_spec", "aroom", "subroom_def", "room_def", "roomfill",
  "room_pos", "subroom_pos", "room_align", "room_size", "room_details",
  "room_detail", "room_name", "room_chance", "room_door", "secret",
  "door_wall", "door_pos", "maze_def", "filling", "regions", "aregion",
  "map_definition", "map_geometry", "h_justif", "v_justif", "reg_init",
  "init_reg", "object_list", "monster_list", "place_list", "$@1",
  "map_details", "map_detail", "monster_detail", "$@2", "monster_infos",
  "monster_info", "object_detail", "object_desc", "$@3", "object_where",
  "object_infos", "curse_state", "monster_id", "enchantment",
  "optional_name", "door_detail", "trap_detail", "drawbridge_detail",
  "mazewalk_detail", "wallify_detail", "ladder_detail", "stair_detail",
  "stair_region", "$@4", "portal_region", "$@5", "teleprt_region", "$@6",
  "$@7", "branch_region", "$@8", "teleprt_detail", "lev_region",
  "fountain_detail", "sink_detail", "pool_detail", "diggable_detail",
  "passwall_detail", "region_detail", "altar_detail", "gold_detail",
  "engraving_detail", "monster_c", "object_c", "m_name", "o_name",
  "trap_name", "room_type", "prefilled", "coordinate", "door_state",
  "light_state", "alignment", "altar_type", "p_register", "o_register",
  "m_register", "a_register", "place", "monster", "object", "string",
  "amount", "chance", "engraving_type", "coord", "region", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      44,    58,    40,    41,    91,    93,   325,   326
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    78,    79,    79,    80,    80,    81,    81,    82,    83,
      84,    85,    85,    85,    86,    86,    87,    87,    88,    88,
      89,    89,    90,    91,    91,    92,    93,    93,    94,    94,
      95,    95,    96,    96,    97,    97,    98,    99,    99,   100,
     100,   101,   102,   102,   103,   104,   105,   105,   106,   106,
     107,   107,   108,   108,   109,   109,   110,   110,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   112,   113,   114,   115,   115,   116,   116,   117,   117,
     118,   119,   119,   120,   120,   121,   122,   122,   123,   124,
     124,   125,   125,   126,   126,   127,   127,   127,   128,   128,
     129,   129,   130,   131,   130,   132,   132,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   135,   134,   136,
     136,   137,   137,   137,   137,   137,   138,   138,   140,   139,
     141,   141,   142,   142,   142,   142,   143,   143,   144,   145,
     145,   146,   146,   146,   147,   148,   149,   150,   151,   152,
     153,   155,   154,   157,   156,   159,   160,   158,   162,   161,
     163,   163,   164,   164,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   174,   174,   175,   175,   175,
     176,   176,   177,   177,   178,   178,   179,   179,   180,   180,
     180,   181,   181,   181,   182,   182,   183,   183,   184,   184,
     184,   185,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   194,   195,   195,   196,   196,   197,   198
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     6,     7,
       3,     0,    13,    15,     1,     1,     0,     3,     3,     1,
       0,     2,     3,     0,     2,     3,     0,     2,     3,     3,
       0,     1,     1,     2,     1,     1,     1,     0,     2,     5,
       5,     7,     2,     2,    12,    12,     0,     2,     5,     1,
       5,     1,     5,     1,     5,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     9,     1,     1,     1,     1,     1,     1,
       5,     1,     1,     1,     2,     3,     1,     2,     5,     1,
       1,     1,     1,     0,     2,     3,     3,     3,     1,     3,
       1,     3,     1,     0,     4,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,    10,     0,
       2,     2,     2,     2,     2,     3,     2,     2,     0,     9,
       1,     1,     0,     7,     5,     5,     1,     1,     1,     1,
       1,     0,     2,     2,     5,     6,     7,     5,     1,     5,
       5,     0,     8,     0,     8,     0,     0,     8,     0,     6,
       0,     2,     1,    10,     3,     3,     3,     3,     3,     3,
       8,     7,     5,     7,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     4,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     5,     9
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     0,     0,     3,     4,     6,     7,    16,    16,
       0,     0,     1,     5,     0,    11,    11,   220,     0,    10,
       0,     0,    20,    20,     0,    19,    17,     0,     0,    26,
      20,    23,    81,    82,    80,     0,     0,     0,    30,    21,
       0,     0,    23,    18,     0,    22,     0,     0,     0,     0,
      27,    37,    31,    32,    56,    56,     0,     0,    86,     8,
      83,    93,     0,    24,     0,     0,     0,     0,     0,    36,
       9,    34,    35,    33,    43,    42,    25,     0,    84,   105,
      87,     0,   219,    28,    98,   218,    29,   100,   197,     0,
     196,     0,     0,    38,   223,   223,   223,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,    58,
      59,    60,    61,    62,    63,    70,    65,    66,    67,    64,
      68,    69,    89,    90,     0,     0,     0,     0,    94,    85,
       0,     0,     0,     0,     0,     0,   224,   136,     0,   137,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   158,
       0,     0,     0,     0,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,   119,   120,   121,   122,   113,   114,
     115,   116,   118,   125,   126,   112,   117,   123,   124,     0,
      99,   101,   206,   207,     0,     0,     0,     0,     0,     0,
       0,    74,    75,     0,   203,     0,     0,     0,   202,   201,
       0,    72,   221,   222,     0,     0,   175,   177,   176,    71,
      92,    91,    88,    95,    97,    96,   102,   217,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,     0,     0,   189,   187,   185,
       0,     0,   186,   184,   195,     0,   194,     0,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,     0,     0,
       0,     0,     0,     0,     0,   161,   172,   178,   179,   163,
     165,   168,     0,    49,     0,     0,    51,     0,     0,     0,
      40,    39,     0,     0,     0,     0,     0,     0,     0,     0,
     210,     0,   208,     0,   209,   160,   182,   225,   226,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   138,   192,     0,   191,     0,   190,   155,     0,   213,
       0,     0,     0,     0,   104,   154,     0,   157,     0,     0,
     159,     0,   174,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,     0,    55,     0,     0,     0,   214,     0,
     215,     0,    76,    77,     0,   227,     0,   212,   211,   181,
     183,     0,     0,     0,     0,     0,     0,     0,   166,   169,
      14,    15,    12,     0,     0,     0,     0,     0,     0,    78,
      79,     0,     0,   127,     0,   216,   156,     0,   198,     0,
       0,     0,   170,     0,    48,     0,    46,    50,     0,    46,
      41,   141,   142,   140,   129,    73,     0,     0,   180,     0,
     162,   164,     0,   167,    13,     0,     0,    45,     0,    44,
       0,   139,   128,     0,   199,     0,   171,    52,    47,    54,
     147,   146,   148,     0,     0,     0,   130,     0,     0,     0,
       0,     0,   132,   133,     0,   134,   131,   228,   200,     0,
     150,   149,     0,   151,   151,   135,   173,     0,     0,   144,
     145,   151,   152,   153,   143
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,     5,     6,     7,     8,    22,   392,    15,
      26,    29,    30,    41,    42,    38,    50,    51,    52,    70,
      71,    72,    93,   197,    53,    54,    55,   437,   285,   288,
     362,   366,    74,   108,   109,   110,   111,   203,   374,   401,
       9,    34,    59,    60,    61,    62,   124,   222,    79,   128,
      83,    86,   225,   264,   129,   168,   112,   424,   442,   456,
     113,   137,   369,   422,   441,   453,   454,   473,   479,   171,
     114,   173,   174,   175,   176,   115,   178,   319,   179,   320,
     180,   321,   412,   181,   322,   433,   275,   116,   117,   118,
     183,   184,   185,   119,   120,   121,   251,   246,   335,   331,
     255,    89,   428,   210,   267,   194,   303,   379,   208,   247,
     252,   304,   226,    87,    84,    90,   214,   138,   309,   209,
     276
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -432
static const yytype_int16 yypact[] =
{
     134,   -30,    41,   101,  -432,   134,  -432,  -432,    57,    57,
      52,    52,  -432,  -432,    66,   139,   139,  -432,    85,  -432,
      94,    99,   172,   172,    15,   113,  -432,   181,   118,  -432,
     172,   183,  -432,  -432,  -432,    94,   123,   116,    29,  -432,
     124,    39,   183,  -432,   191,  -432,   125,   126,   127,   128,
    -432,   155,  -432,    -6,  -432,  -432,   129,   130,  -432,  -432,
      39,  -432,   131,  -432,   132,   200,   201,     4,     4,  -432,
    -432,  -432,   168,  -432,     5,     5,  -432,    30,  -432,   122,
    -432,   202,  -432,  -432,   140,  -432,  -432,   141,  -432,   142,
    -432,   143,   138,  -432,   208,   208,   208,   208,   144,   145,
     146,   148,   149,   150,   151,   152,   153,   154,  -432,  -432,
    -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,
    -432,  -432,  -432,  -432,   156,   157,   158,   159,  -432,   147,
     162,   200,   201,    89,    89,   161,  -432,  -432,   163,  -432,
     164,   165,    20,   -15,   -15,   214,    23,   -15,   -15,   -15,
     -15,    52,    95,   200,   201,   166,   169,   170,   171,  -432,
     173,   174,   175,   176,   177,   178,   179,   180,  -432,  -432,
    -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,
    -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,  -432,   222,
    -432,  -432,  -432,  -432,   167,   182,   235,   184,    21,    14,
       9,  -432,  -432,   185,  -432,   186,   239,   187,  -432,  -432,
     188,  -432,  -432,  -432,   189,   193,  -432,  -432,  -432,  -432,
    -432,  -432,  -432,  -432,  -432,  -432,   194,  -432,    78,   -15,
     -15,   195,   -15,    28,   195,   195,    -3,    -3,    -3,   196,
      35,    51,   198,    12,  -432,   197,   199,  -432,  -432,  -432,
     203,   204,  -432,  -432,  -432,   205,  -432,    78,   249,   206,
      64,   209,   -15,   100,   210,  -432,  -432,   211,   212,   216,
     252,   217,   218,   207,   257,  -432,  -432,  -432,  -432,  -432,
    -432,  -432,    89,  -432,   261,   219,  -432,   268,   220,   223,
    -432,  -432,   274,    19,   280,    27,   -15,   221,   224,   288,
    -432,   226,  -432,   225,  -432,  -432,  -432,  -432,  -432,   227,
     166,   -15,   243,   244,   228,    89,   240,     8,   232,   233,
     234,   236,   237,   238,   241,    53,   242,    54,   245,   230,
    -432,  -432,  -432,   246,  -432,   248,  -432,  -432,   107,  -432,
     247,   292,   -11,    52,  -432,  -432,   253,  -432,   305,   254,
    -432,   255,  -432,   306,    -3,    -3,    -3,    -3,    26,   309,
    -432,    30,   256,   310,  -432,   312,   258,    24,  -432,   259,
    -432,   -15,  -432,  -432,   260,  -432,   262,  -432,  -432,  -432,
    -432,    78,   264,     4,   315,    72,   265,   266,  -432,  -432,
    -432,  -432,   269,   267,   271,    54,   270,   272,    52,  -432,
    -432,   273,    45,  -432,    24,  -432,  -432,   318,   275,   277,
     283,    52,   278,   322,  -432,    95,   279,  -432,   327,   279,
    -432,  -432,   281,  -432,  -432,  -432,   282,   330,  -432,   328,
    -432,  -432,   289,  -432,  -432,   284,   333,  -432,   285,  -432,
     -13,  -432,   286,   350,   290,   291,  -432,  -432,  -432,  -432,
    -432,  -432,  -432,   293,   294,    42,  -432,   295,   354,   351,
       7,    25,  -432,  -432,    52,  -432,  -432,  -432,  -432,   296,
    -432,  -432,   297,   300,   300,  -432,  -432,    25,   -14,  -432,
    -432,   300,  -432,  -432,  -432
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -432,  -432,   357,  -432,  -432,  -432,  -432,   349,  -432,   362,
     331,    83,  -432,   332,  -432,  -432,  -432,  -432,   319,  -432,
    -432,  -432,  -432,   133,  -432,  -432,  -432,   -46,  -432,  -432,
    -432,   -20,   323,  -432,  -432,  -432,  -432,  -432,  -432,   -27,
    -432,  -432,   320,  -432,  -432,  -432,    18,   -34,  -432,  -432,
     -94,   -38,    73,  -432,  -432,  -432,   263,  -432,  -432,  -432,
     276,   287,  -432,  -432,  -432,  -432,   -76,  -350,  -431,  -432,
     298,  -432,  -432,  -432,  -432,   299,  -432,  -432,  -432,  -432,
    -432,  -432,  -432,  -432,  -432,  -432,  -223,   301,  -432,  -432,
    -432,  -432,  -432,   302,   303,   304,  -432,  -432,  -432,  -432,
    -432,   -66,  -432,  -140,  -251,  -130,   -70,  -432,  -432,  -432,
    -432,  -432,  -432,   190,   192,   -10,  -432,    76,  -432,  -150,
     -96
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -104
static const yytype_int16 yytable[] =
{
      18,    19,    91,   207,   195,   227,   297,   215,   216,   217,
     218,   470,   351,   279,   280,   281,   290,    85,    32,    94,
      95,    96,    97,    98,    82,   201,    48,   212,   399,   470,
     482,   390,    99,   273,   100,   450,   204,   190,   451,   205,
     377,    10,   101,   480,   102,   103,   104,   105,   106,   378,
     484,    57,    58,    46,    47,    88,    49,   206,   471,   223,
     254,    48,   483,   452,   273,   249,    33,   250,   107,   270,
     330,   202,   244,   245,   213,   400,   471,   391,   334,   204,
      17,   352,   205,   452,   196,    17,   283,   122,   123,   268,
     269,    49,   272,   300,   191,    17,   204,   301,   302,   205,
     274,    12,   286,    17,   360,   364,    31,   284,   462,   463,
     464,   474,    11,    39,   421,   300,   224,   206,    17,   301,
     302,    14,   306,   287,   265,   361,   365,   481,    17,   266,
     406,   386,   387,   388,   389,   271,   192,    20,   277,   278,
     193,   219,   407,     1,     2,   375,   125,   126,   127,   307,
      21,   308,   323,   220,   221,    24,   337,   372,   373,    25,
     227,    94,    95,    96,    97,   156,   157,   158,   159,   160,
      27,   345,   140,   141,    99,   161,   162,   163,   164,    28,
     165,   166,   167,    35,    36,   349,   102,   103,   104,    37,
     256,    40,    45,    44,    64,    56,    65,    66,    67,    68,
      69,    77,    81,    82,    85,    76,    92,   130,    80,   135,
     131,   132,   133,   134,   136,   142,   143,   144,   211,   145,
     146,   147,   148,   149,   150,   151,   152,   239,   153,   154,
     155,   403,   189,   196,   198,   199,   200,   240,   206,   242,
     228,   229,   230,   259,   231,   232,   233,   234,   235,   236,
     237,   238,   241,   298,   243,   257,   314,   260,   261,   262,
     258,   318,   423,   263,  -103,   324,   282,   270,   289,   293,
     305,   292,   326,   328,   295,   296,   299,   294,   329,   317,
     310,   311,   312,   332,   333,   336,   313,   315,   316,   325,
     327,   338,   340,   346,   347,   342,   376,   343,   348,   339,
     341,   350,   353,   354,   355,   368,   356,   357,   358,   382,
     385,   359,   363,   393,   396,   367,   397,   408,   371,   409,
     375,   370,   426,   381,   383,   384,   395,   434,   398,   402,
     404,   438,   445,   380,   407,   410,   411,   405,   448,   413,
     414,   415,   418,   417,   430,   427,   420,   429,   432,   436,
     446,   440,   443,   444,   457,   469,   455,   447,   449,   468,
     458,   459,    13,   460,   461,    23,    43,   477,   467,   476,
     478,    16,    73,   439,    63,   416,   291,   425,    75,   394,
      78,   435,   139,   344,   472,   465,     0,     0,   419,   253,
     248,     0,   169,     0,     0,     0,     0,     0,     0,     0,
       0,   431,     0,     0,     0,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   177,     0,
     182,   186,   187,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   466,     0,     0,     0,     0,
       0,     0,     0,     0,   475
};

static const yytype_int16 yycheck[] =
{
      10,    11,    68,   143,   134,   155,   257,   147,   148,   149,
     150,     4,     4,   236,   237,   238,     4,     3,     3,    14,
      15,    16,    17,    18,     3,     5,    32,     4,     4,     4,
      44,     5,    27,    36,    29,    48,    51,   131,    51,    54,
      51,    71,    37,   474,    39,    40,    41,    42,    43,    60,
     481,    12,    13,    24,    25,    51,    62,    72,    51,   153,
      51,    32,    76,    76,    36,    51,    51,    53,    63,    72,
      51,    51,    51,    52,    51,    51,    51,    51,    51,    51,
      76,    73,    54,    76,    72,    76,    51,    57,    58,   229,
     230,    62,   232,    51,   132,    76,    51,    55,    56,    54,
      72,     0,    51,    76,    51,    51,    23,    72,    66,    67,
      68,   461,    71,    30,    69,    51,   154,    72,    76,    55,
      56,    64,   262,    72,    46,    72,    72,   477,    76,    51,
     381,   354,   355,   356,   357,   231,    47,    71,   234,   235,
      51,   151,    70,     9,    10,    73,    24,    25,    26,    49,
      11,    51,   282,    58,    59,    70,   296,    50,    51,    65,
     310,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      71,   311,    96,    97,    27,    28,    29,    30,    31,     7,
      33,    34,    35,    70,     3,   315,    39,    40,    41,    71,
     200,     8,    76,    70,     3,    71,    71,    71,    71,    71,
      45,    71,    70,     3,     3,    76,    38,     5,    77,    71,
      70,    70,    70,    70,     6,    71,    71,    71,     4,    71,
      71,    71,    71,    71,    71,    71,    70,     5,    71,    71,
      71,   371,    70,    72,    71,    71,    71,    70,    72,     4,
      71,    71,    71,     4,    71,    71,    71,    71,    71,    71,
      71,    71,    70,     4,    70,    70,     4,    70,    70,    70,
      74,     4,   402,    70,    70,     4,    70,    72,    70,    70,
      61,    74,     4,    50,    70,    70,    70,    74,     4,    72,
      70,    70,    70,   293,     4,   295,    70,    70,    70,    70,
      70,    70,     4,    50,    50,    70,     4,    70,    70,    75,
      74,    61,    70,    70,    70,    75,    70,    70,    70,     4,
       4,    70,    70,     4,     4,    70,     4,   383,    70,     4,
      73,    75,     4,    70,    70,    70,    70,     5,    70,    70,
      70,     4,     4,   343,    70,    70,    70,    75,     5,    70,
      73,    70,    70,    73,    61,    70,    73,    70,    70,    70,
      61,    70,    70,    23,     4,     4,    70,    73,    73,     5,
      70,    70,     5,    70,    70,    16,    35,    70,    73,    73,
      70,     9,    53,   419,    42,   395,   243,   404,    55,   361,
      60,   415,    95,   310,   460,   455,    -1,    -1,   398,   199,
     198,    -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   411,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   129,    -1,
     129,   129,   129,   129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   464
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     9,    10,    79,    80,    81,    82,    83,    84,   118,
      71,    71,     0,    80,    64,    87,    87,    76,   193,   193,
      71,    11,    85,    85,    70,    65,    88,    71,     7,    89,
      90,    89,     3,    51,   119,    70,     3,    71,    93,    89,
       8,    91,    92,    88,    70,    76,    24,    25,    32,    62,
      94,    95,    96,   102,   103,   104,    71,    12,    13,   120,
     121,   122,   123,    91,     3,    71,    71,    71,    71,    45,
      97,    98,    99,    96,   110,   110,    76,    71,   120,   126,
      77,    70,     3,   128,   192,     3,   129,   191,    51,   179,
     193,   179,    38,   100,    14,    15,    16,    17,    18,    27,
      29,    37,    39,    40,    41,    42,    43,    63,   111,   112,
     113,   114,   134,   138,   148,   153,   165,   166,   167,   171,
     172,   173,    57,    58,   124,    24,    25,    26,   127,   132,
       5,    70,    70,    70,    70,    71,     6,   139,   195,   139,
     195,   195,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    70,    71,    71,    71,    18,    19,    20,    21,
      22,    28,    29,    30,    31,    33,    34,    35,   133,   134,
     138,   147,   148,   149,   150,   151,   152,   153,   154,   156,
     158,   161,   165,   168,   169,   170,   171,   172,   173,    70,
     128,   129,    47,    51,   183,   183,    72,   101,    71,    71,
      71,     5,    51,   115,    51,    54,    72,   181,   186,   197,
     181,     4,     4,    51,   194,   181,   181,   181,   181,   193,
      58,    59,   125,   128,   129,   130,   190,   197,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,     5,
      70,    70,     4,    70,    51,    52,   175,   187,   192,    51,
      53,   174,   188,   191,    51,   178,   193,    70,    74,     4,
      70,    70,    70,    70,   131,    46,    51,   182,   181,   181,
      72,   198,   181,    36,    72,   164,   198,   198,   198,   164,
     164,   164,    70,    51,    72,   106,    51,    72,   107,    70,
       4,   101,    74,    70,    74,    70,    70,   182,     4,    70,
      51,    55,    56,   184,   189,    61,   181,    49,    51,   196,
      70,    70,    70,    70,     4,    70,    70,    72,     4,   155,
     157,   159,   162,   183,     4,    70,     4,    70,    50,     4,
      51,   177,   193,     4,    51,   176,   193,   181,    70,    75,
       4,    74,    70,    70,   130,   181,    50,    50,    70,   183,
      61,     4,    73,    70,    70,    70,    70,    70,    70,    70,
      51,    72,   108,    70,    51,    72,   109,    70,    75,   140,
      75,    70,    50,    51,   116,    73,     4,    51,    60,   185,
     193,    70,     4,    70,    70,     4,   164,   164,   164,   164,
       5,    51,    86,     4,   124,    70,     4,     4,    70,     4,
      51,   117,    70,   181,    70,    75,   182,    70,   179,     4,
      70,    70,   160,    70,    73,    70,   109,    73,    70,   193,
      73,    69,   141,   181,   135,   117,     4,    70,   180,    70,
      61,   193,    70,   163,     5,   125,    70,   105,     4,   105,
      70,   142,   136,    70,    23,     4,    61,    73,     5,    73,
      48,    51,    76,   143,   144,    70,   137,     4,    70,    70,
      70,    70,    66,    67,    68,   184,   193,    73,     5,     4,
       4,    51,   144,   145,   145,   193,    73,    70,    70,   146,
     146,   145,    44,    76,   146
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:

/* Line 1455 of yacc.c  */
#line 149 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			unsigned i;

			if (fatal_error > 0) {
				(void) fprintf(stderr,
				"%s : %d errors detected. No output created!\n",
					fname, fatal_error);
			} else {
				maze.flags = (yyvsp[(2) - (6)].i);
				(void) memcpy(&(maze.init_lev),
						&(init_lev),
						sizeof(lev_init));
				maze.numpart = npart;
				maze.parts = NewTab(mazepart, npart);
				for(i=0;i<npart;i++)
				    maze.parts[i] = tmppart[i];
				if (!write_level_file((yyvsp[(1) - (6)].map), NULL, &maze)) {
					yyerror("Can't write output file!!");
					exit(EXIT_FAILURE);
				}
				npart = 0;
			}
			Free((yyvsp[(1) - (6)].map));
		  ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 176 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			unsigned i;

			if (fatal_error > 0) {
			    (void) fprintf(stderr,
			      "%s : %d errors detected. No output created!\n",
					fname, fatal_error);
			} else {
				special_lev.flags = (long) (yyvsp[(2) - (7)].i);
				(void) memcpy(
					&(special_lev.init_lev),
					&(init_lev),
					sizeof(lev_init));
				special_lev.nroom = nrooms;
				special_lev.rooms = NewTab(room, nrooms);
				for(i=0; i<nrooms; i++)
				    special_lev.rooms[i] = tmproom[i];
				special_lev.ncorr = ncorridor;
				special_lev.corrs = NewTab(corridor, ncorridor);
				for(i=0; i<ncorridor; i++)
				    special_lev.corrs[i] = tmpcor[i];
				if (check_subrooms()) {
				    if (!write_level_file((yyvsp[(1) - (7)].map), &special_lev,
							  NULL)) {
					yyerror("Can't write output file!!");
					exit(EXIT_FAILURE);
				    }
				}
				free_rooms(&special_lev);
				nrooms = 0;
				ncorridor = 0;
			}
			Free((yyvsp[(1) - (7)].map));
		  ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 213 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (strchr((yyvsp[(3) - (3)].map), '.'))
			    yyerror("Invalid dot ('.') in level name.");
			if ((int) strlen((yyvsp[(3) - (3)].map)) > 8)
			    yyerror("Level names limited to 8 characters.");
			(yyval.map) = (yyvsp[(3) - (3)].map);
			special_lev.nrmonst = special_lev.nrobjects = 0;
			n_mlist = n_olist = 0;
		  ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 225 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			/* in case we're processing multiple files,
			   explicitly clear any stale settings */
			(void) memset(&init_lev, 0,
					sizeof init_lev);
			init_lev.init_present = FALSE;
			(yyval.i) = 0;
		  ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 234 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			init_lev.init_present = TRUE;
			init_lev.fg = what_map_char((char) (yyvsp[(3) - (13)].i));
			if (init_lev.fg == INVALID_TYPE)
			    yyerror("Invalid foreground type.");
			init_lev.bg = what_map_char((char) (yyvsp[(5) - (13)].i));
			if (init_lev.bg == INVALID_TYPE)
			    yyerror("Invalid background type.");
			init_lev.smoothed = (yyvsp[(7) - (13)].i);
			init_lev.joined = (yyvsp[(9) - (13)].i);
			if (init_lev.joined &&
			    init_lev.fg != CORR && init_lev.fg != ROOM)
			    yyerror("Invalid foreground type for joined map.");
			init_lev.lit = (yyvsp[(11) - (13)].i);
			init_lev.walled = (yyvsp[(13) - (13)].i);
                        init_lev.icedpools = FALSE;
			(yyval.i) = 1;
		  ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 253 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
                        init_lev.init_present = TRUE;
                        init_lev.fg = what_map_char((char) (yyvsp[(3) - (15)].i));
                        if (init_lev.fg == INVALID_TYPE)
                            yyerror("Invalid foreground type.");
                        init_lev.bg = what_map_char((char) (yyvsp[(5) - (15)].i));
                        if (init_lev.bg == INVALID_TYPE)
                            yyerror("Invalid background type.");
                        init_lev.smoothed = (yyvsp[(7) - (15)].i);
                        init_lev.joined = (yyvsp[(9) - (15)].i);
                        if (init_lev.joined &&
                            init_lev.fg != CORR && init_lev.fg != ROOM)
                            yyerror("Invalid foreground type for joined map.");
                        init_lev.lit = (yyvsp[(11) - (15)].i);
                        init_lev.walled = (yyvsp[(13) - (15)].i);
                        init_lev.icedpools = (yyvsp[(15) - (15)].i);
                        (yyval.i) = 1;
                  ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 279 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = 0;
		  ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 283 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = lev_flags;
			lev_flags = 0;	/* clear for next user */
		  ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 290 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			lev_flags |= (yyvsp[(1) - (3)].i);
		  ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 294 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			lev_flags |= (yyvsp[(1) - (1)].i);
		  ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 304 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			int i, j;

			i = (int) strlen((yyvsp[(3) - (3)].map)) + 1;
			j = (int) strlen(tmpmessage);
			if (i + j > 255) {
			   yyerror("Message string too long (>256 characters)");
			} else {
			    if (j) tmpmessage[j++] = '\n';
			    (void) strncpy(tmpmessage+j, (yyvsp[(3) - (3)].map), i - 1);
			    tmpmessage[j + i - 1] = 0;
			}
			Free((yyvsp[(3) - (3)].map));
		  ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 325 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			int i, j;

			i = (int) strlen((yyvsp[(3) - (3)].map)) + 1;
			j = (int) strlen(tmphallumsg);
			if (i + j > 255) {
			   yyerror("Message string too long (>256 characters)");
			} else {
			    if (j) tmphallumsg[j++] = '\n';
			    (void) strncpy(tmphallumsg+j, (yyvsp[(3) - (3)].map), i - 1);
			    tmphallumsg[j + i - 1] = 0;
			}
			Free((yyvsp[(3) - (3)].map));
		  ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 347 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if(special_lev.nrobjects) {
			    yyerror("Object registers already initialized!");
			} else {
			    special_lev.nrobjects = n_olist;
			    special_lev.robjects = malloc(n_olist);
			    (void) memcpy(special_lev.robjects,
					  olist, n_olist);
			}
		  ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 358 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if(special_lev.nrmonst) {
			    yyerror("Monster registers already initialized!");
			} else {
			    special_lev.nrmonst = n_mlist;
			    special_lev.rmonst = malloc(n_mlist);
			    (void) memcpy(special_lev.rmonst,
					  mlist, n_mlist);
			  }
		  ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 371 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmproom[nrooms] = New(room);
			tmproom[nrooms]->name = NULL;
			tmproom[nrooms]->parent = NULL;
			tmproom[nrooms]->rtype = 0;
			tmproom[nrooms]->rlit = 0;
			tmproom[nrooms]->xalign = ERR;
			tmproom[nrooms]->yalign = ERR;
			tmproom[nrooms]->x = 0;
			tmproom[nrooms]->y = 0;
			tmproom[nrooms]->w = 2;
			tmproom[nrooms]->h = 2;
			in_room = 1;
		  ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 397 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpcor[0] = New(corridor);
			tmpcor[0]->src.room = -1;
			ncorridor = 1;
		  ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 409 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpcor[ncorridor] = New(corridor);
			tmpcor[ncorridor]->src.room = (yyvsp[(3) - (5)].corpos).room;
			tmpcor[ncorridor]->src.wall = (yyvsp[(3) - (5)].corpos).wall;
			tmpcor[ncorridor]->src.door = (yyvsp[(3) - (5)].corpos).door;
			tmpcor[ncorridor]->dest.room = (yyvsp[(5) - (5)].corpos).room;
			tmpcor[ncorridor]->dest.wall = (yyvsp[(5) - (5)].corpos).wall;
			tmpcor[ncorridor]->dest.door = (yyvsp[(5) - (5)].corpos).door;
			ncorridor++;
			if (ncorridor >= MAX_OF_TYPE) {
				yyerror("Too many corridors in level!");
				ncorridor--;
			}
		  ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 424 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpcor[ncorridor] = New(corridor);
			tmpcor[ncorridor]->src.room = (yyvsp[(3) - (5)].corpos).room;
			tmpcor[ncorridor]->src.wall = (yyvsp[(3) - (5)].corpos).wall;
			tmpcor[ncorridor]->src.door = (yyvsp[(3) - (5)].corpos).door;
			tmpcor[ncorridor]->dest.room = -1;
			tmpcor[ncorridor]->dest.wall = (yyvsp[(5) - (5)].i);
			ncorridor++;
			if (ncorridor >= MAX_OF_TYPE) {
				yyerror("Too many corridors in level!");
				ncorridor--;
			}
		  ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 440 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ((unsigned) (yyvsp[(2) - (7)].i) >= nrooms)
			    yyerror("Wrong room number!");
			(yyval.corpos).room = (yyvsp[(2) - (7)].i);
			(yyval.corpos).wall = (yyvsp[(4) - (7)].i);
			(yyval.corpos).door = (yyvsp[(6) - (7)].i);
		  ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 450 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			store_room();
		  ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 454 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			store_room();
		  ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 460 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmproom[nrooms] = New(room);
			tmproom[nrooms]->parent = (yyvsp[(11) - (12)].map);
			tmproom[nrooms]->name = NULL;
			tmproom[nrooms]->rtype = (yyvsp[(3) - (12)].i);
			tmproom[nrooms]->rlit = (yyvsp[(5) - (12)].i);
			tmproom[nrooms]->filled = (yyvsp[(12) - (12)].i);
			tmproom[nrooms]->xalign = ERR;
			tmproom[nrooms]->yalign = ERR;
			tmproom[nrooms]->x = current_coord.x;
			tmproom[nrooms]->y = current_coord.y;
			tmproom[nrooms]->w = current_size.width;
			tmproom[nrooms]->h = current_size.height;
			in_room = 1;
		  ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 478 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmproom[nrooms] = New(room);
			tmproom[nrooms]->name = NULL;
			tmproom[nrooms]->parent = NULL;
			tmproom[nrooms]->rtype = (yyvsp[(3) - (12)].i);
			tmproom[nrooms]->rlit = (yyvsp[(5) - (12)].i);
			tmproom[nrooms]->filled = (yyvsp[(12) - (12)].i);
			tmproom[nrooms]->xalign = current_align.x;
			tmproom[nrooms]->yalign = current_align.y;
			tmproom[nrooms]->x = current_coord.x;
			tmproom[nrooms]->y = current_coord.y;
			tmproom[nrooms]->w = current_size.width;
			tmproom[nrooms]->h = current_size.height;
			in_room = 1;
		  ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 496 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = 1;
		  ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 500 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = (yyvsp[(2) - (2)].i);
		  ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 506 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ( (yyvsp[(2) - (5)].i) < 1 || (yyvsp[(2) - (5)].i) > 5 ||
			    (yyvsp[(4) - (5)].i) < 1 || (yyvsp[(4) - (5)].i) > 5 ) {
			    yyerror("Room position should be between 1 & 5!");
			} else {
			    current_coord.x = (yyvsp[(2) - (5)].i);
			    current_coord.y = (yyvsp[(4) - (5)].i);
			}
		  ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 516 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_coord.x = current_coord.y = ERR;
		  ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 522 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ( (yyvsp[(2) - (5)].i) < 0 || (yyvsp[(4) - (5)].i) < 0) {
			    yyerror("Invalid subroom position !");
			} else {
			    current_coord.x = (yyvsp[(2) - (5)].i);
			    current_coord.y = (yyvsp[(4) - (5)].i);
			}
		  ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 531 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_coord.x = current_coord.y = ERR;
		  ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 537 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_align.x = (yyvsp[(2) - (5)].i);
			current_align.y = (yyvsp[(4) - (5)].i);
		  ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 542 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_align.x = current_align.y = ERR;
		  ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 548 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_size.width = (yyvsp[(2) - (5)].i);
			current_size.height = (yyvsp[(4) - (5)].i);
		  ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 553 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_size.height = current_size.width = ERR;
		  ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 578 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (tmproom[nrooms]->name)
			    yyerror("This room already has a name!");
			else
			    tmproom[nrooms]->name = (yyvsp[(3) - (3)].map);
		  ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 587 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (tmproom[nrooms]->chance)
			    yyerror("This room already assigned a chance!");
			else if (tmproom[nrooms]->rtype == OROOM)
			    yyerror("Only typed rooms can have a chance!");
			else if ((yyvsp[(3) - (3)].i) < 1 || (yyvsp[(3) - (3)].i) > 99)
			    yyerror("The chance is supposed to be percentile.");
			else
			    tmproom[nrooms]->chance = (yyvsp[(3) - (3)].i);
		   ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 600 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			/* ERR means random here */
			if ((yyvsp[(7) - (9)].i) == ERR && (yyvsp[(9) - (9)].i) != ERR) {
		     yyerror("If the door wall is random, so must be its pos!");
			} else {
			    tmprdoor[ndoor] = New(room_door);
			    tmprdoor[ndoor]->secret = (yyvsp[(3) - (9)].i);
			    tmprdoor[ndoor]->mask = (yyvsp[(5) - (9)].i);
			    tmprdoor[ndoor]->wall = (yyvsp[(7) - (9)].i);
			    tmprdoor[ndoor]->pos = (yyvsp[(9) - (9)].i);
			    ndoor++;
			    if (ndoor >= MAX_OF_TYPE) {
				    yyerror("Too many doors in room!");
				    ndoor--;
			    }
			}
		  ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 632 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			maze.filling = (schar) (yyvsp[(5) - (5)].i);
			if (strchr((yyvsp[(3) - (5)].map), '.'))
			    yyerror("Invalid dot ('.') in level name.");
			if ((int) strlen((yyvsp[(3) - (5)].map)) > 8)
			    yyerror("Level names limited to 8 characters.");
			(yyval.map) = (yyvsp[(3) - (5)].map);
			in_room = 0;
			n_plist = n_mlist = n_olist = 0;
		  ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 645 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = get_floor_type((char)(yyvsp[(1) - (1)].i));
		  ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 649 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = -1;
		  ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 659 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			store_part();
		  ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 665 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmppart[npart] = New(mazepart);
			tmppart[npart]->halign = 1;
			tmppart[npart]->valign = 1;
			tmppart[npart]->nrobjects = 0;
			tmppart[npart]->nloc = 0;
			tmppart[npart]->nrmonst = 0;
			tmppart[npart]->xsize = 1;
			tmppart[npart]->ysize = 1;
			tmppart[npart]->map = malloc(sizeof(char *));
			tmppart[npart]->map[0] = malloc(1);
			tmppart[npart]->map[0][0] = STONE;
			max_x_map = COLNO-1;
			max_y_map = ROWNO;
		  ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 681 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmppart[npart] = New(mazepart);
			tmppart[npart]->halign = (yyvsp[(1) - (2)].i) % 10;
			tmppart[npart]->valign = (yyvsp[(1) - (2)].i) / 10;
			tmppart[npart]->nrobjects = 0;
			tmppart[npart]->nloc = 0;
			tmppart[npart]->nrmonst = 0;
			scan_map((yyvsp[(2) - (2)].map));
			Free((yyvsp[(2) - (2)].map));
		  ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 694 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = (yyvsp[(3) - (5)].i) + ((yyvsp[(5) - (5)].i) * 10);
		  ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 712 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (tmppart[npart]->nrobjects) {
			    yyerror("Object registers already initialized!");
			} else {
			    tmppart[npart]->robjects = malloc(n_olist);
			    (void) memcpy(tmppart[npart]->robjects,
					  olist, n_olist);
			    tmppart[npart]->nrobjects = n_olist;
			}
		  ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 723 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (tmppart[npart]->nloc) {
			    yyerror("Location registers already initialized!");
			} else {
			    int i;
			    tmppart[npart]->rloc_x = malloc(n_plist);
			    tmppart[npart]->rloc_y = malloc(n_plist);
			    for(i=0;i<n_plist;i++) {
				tmppart[npart]->rloc_x[i] = plist[i].x;
				tmppart[npart]->rloc_y[i] = plist[i].y;
			    }
			    tmppart[npart]->nloc = n_plist;
			}
		  ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 738 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (tmppart[npart]->nrmonst) {
			    yyerror("Monster registers already initialized!");
			} else {
			    tmppart[npart]->rmonst = malloc(n_mlist);
			    (void) memcpy(tmppart[npart]->rmonst,
					  mlist, n_mlist);
			    tmppart[npart]->nrmonst = n_mlist;
			}
		  ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 751 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (n_olist < MAX_REGISTERS)
			    olist[n_olist++] = (yyvsp[(1) - (1)].i);
			else
			    yyerror("Object list too long!");
		  ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 758 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (n_olist < MAX_REGISTERS)
			    olist[n_olist++] = (yyvsp[(1) - (3)].i);
			else
			    yyerror("Object list too long!");
		  ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 767 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (n_mlist < MAX_REGISTERS)
			    mlist[n_mlist++] = (yyvsp[(1) - (1)].i);
			else
			    yyerror("Monster list too long!");
		  ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 774 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (n_mlist < MAX_REGISTERS)
			    mlist[n_mlist++] = (yyvsp[(1) - (3)].i);
			else
			    yyerror("Monster list too long!");
		  ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 783 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (n_plist < MAX_REGISTERS)
			    plist[n_plist++] = current_coord;
			else
			    yyerror("Location list too long!");
		  ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 790 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (n_plist < MAX_REGISTERS)
			    plist[n_plist++] = current_coord;
			else
			    yyerror("Location list too long!");
		  ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 826 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpmonst[nmons] = New(monster);
			tmpmonst[nmons]->x = current_coord.x;
			tmpmonst[nmons]->y = current_coord.y;
			tmpmonst[nmons]->class = (yyvsp[(4) - (8)].i);
			tmpmonst[nmons]->peaceful = -1; /* no override */
			tmpmonst[nmons]->asleep = -1;
			tmpmonst[nmons]->align = - MAX_REGISTERS - 2;
			tmpmonst[nmons]->name.str = 0;
			tmpmonst[nmons]->appear = 0;
			tmpmonst[nmons]->appear_as.str = 0;
			tmpmonst[nmons]->chance = (yyvsp[(2) - (8)].i);
			tmpmonst[nmons]->id = NON_PM;
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Monster");
			if ((yyvsp[(6) - (8)].map)) {
			    int token = get_monster_id((yyvsp[(6) - (8)].map), (char) (yyvsp[(4) - (8)].i));
			    if (token == ERR)
				yywarning(
			      "Invalid monster name!  Making random monster.");
			    else
				tmpmonst[nmons]->id = token;
			    Free((yyvsp[(6) - (8)].map));
			}
		  ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 853 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (++nmons >= MAX_OF_TYPE) {
			    yyerror("Too many monsters in room or mazepart!");
			    nmons--;
			}
		  ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 866 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpmonst[nmons]->name.str = (yyvsp[(2) - (2)].map);
		  ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 870 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpmonst[nmons]->peaceful = (yyvsp[(2) - (2)].i);
		  ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 874 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpmonst[nmons]->asleep = (yyvsp[(2) - (2)].i);
		  ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 878 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpmonst[nmons]->align = (yyvsp[(2) - (2)].i);
		  ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 882 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpmonst[nmons]->appear = (yyvsp[(2) - (3)].i);
			tmpmonst[nmons]->appear_as.str = (yyvsp[(3) - (3)].map);
		  ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 889 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
		  ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 892 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			/* 1: is contents of preceeding object with 2 */
			/* 2: is a container */
			/* 0: neither */
			tmpobj[nobj-1]->containment = 2;
		  ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 901 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj] = New(object);
			tmpobj[nobj]->class = (yyvsp[(3) - (5)].i);
			tmpobj[nobj]->corpsenm = NON_PM;
			tmpobj[nobj]->curse_state = -1;
			tmpobj[nobj]->name.str = 0;
			tmpobj[nobj]->chance = (yyvsp[(1) - (5)].i);
			tmpobj[nobj]->id = -1;
			if ((yyvsp[(5) - (5)].map)) {
			    int token = get_object_id((yyvsp[(5) - (5)].map), (yyvsp[(3) - (5)].i));
			    if (token == ERR)
				yywarning(
				"Illegal object name!  Making random object.");
			     else
				tmpobj[nobj]->id = token;
			    Free((yyvsp[(5) - (5)].map));
			}
		  ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 920 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (++nobj >= MAX_OF_TYPE) {
			    yyerror("Too many objects in room or mazepart!");
			    nobj--;
			}
		  ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 929 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->containment = 0;
			tmpobj[nobj]->x = current_coord.x;
			tmpobj[nobj]->y = current_coord.y;
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Object");
		  ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 938 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->containment = 1;
			/* random coordinate, will be overridden anyway */
			tmpobj[nobj]->x = -MAX_REGISTERS-1;
			tmpobj[nobj]->y = -MAX_REGISTERS-1;
		  ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 947 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->spe = -127;
	/* Note below: we're trying to make as many of these optional as
	 * possible.  We clearly can't make curse_state, enchantment, and
	 * monster_id _all_ optional, since ",random" would be ambiguous.
	 * We can't even just make enchantment mandatory, since if we do that
	 * alone, ",random" requires too much lookahead to parse.
	 */
		  ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 957 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
		  ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 960 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
		  ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 963 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
		  ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 968 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->curse_state = -1;
		  ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 972 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->curse_state = (yyvsp[(1) - (1)].i);
		  ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 978 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			int token = get_monster_id((yyvsp[(1) - (1)].map), (char)0);
			if (token == ERR)	/* "random" */
			    tmpobj[nobj]->corpsenm = NON_PM - 1;
			else
			    tmpobj[nobj]->corpsenm = token;
			Free((yyvsp[(1) - (1)].map));
		  ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 989 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->spe = -127;
		  ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 993 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->spe = (yyvsp[(1) - (1)].i);
		  ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1000 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
		  ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1003 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpobj[nobj]->name.str = (yyvsp[(2) - (2)].map);
		  ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1009 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpdoor[ndoor] = New(door);
			tmpdoor[ndoor]->x = current_coord.x;
			tmpdoor[ndoor]->y = current_coord.y;
			tmpdoor[ndoor]->mask = (yyvsp[(3) - (5)].i);
			if(current_coord.x >= 0 && current_coord.y >= 0 &&
			   tmpmap[current_coord.y][current_coord.x] != DOOR &&
			   tmpmap[current_coord.y][current_coord.x] != SDOOR)
			    yyerror("Door decl doesn't match the map");
			ndoor++;
			if (ndoor >= MAX_OF_TYPE) {
				yyerror("Too many doors in mazepart!");
				ndoor--;
			}
		  ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1027 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmptrap[ntrap] = New(trap);
			tmptrap[ntrap]->x = current_coord.x;
			tmptrap[ntrap]->y = current_coord.y;
			tmptrap[ntrap]->type = (yyvsp[(4) - (6)].i);
			tmptrap[ntrap]->chance = (yyvsp[(2) - (6)].i);
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Trap");
			if (++ntrap >= MAX_OF_TYPE) {
				yyerror("Too many traps in room or mazepart!");
				ntrap--;
			}
		  ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1044 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
		        int x, y, dir;

			tmpdb[ndb] = New(drawbridge);
			x = tmpdb[ndb]->x = current_coord.x;
			y = tmpdb[ndb]->y = current_coord.y;
			/* convert dir from a DIRECTION to a DB_DIR */
			dir = (yyvsp[(5) - (7)].i);
			switch(dir) {
			case W_NORTH: dir = DB_NORTH; y--; break;
			case W_SOUTH: dir = DB_SOUTH; y++; break;
			case W_EAST:  dir = DB_EAST;  x++; break;
			case W_WEST:  dir = DB_WEST;  x--; break;
			default:
			    yyerror("Invalid drawbridge direction");
			    break;
			}
			tmpdb[ndb]->dir = dir;
			if (current_coord.x >= 0 && current_coord.y >= 0 &&
			    !IS_WALL(tmpmap[y][x])) {
			    char ebuf[60];
			    snprintf(ebuf, SIZE(ebuf),
				    "Wall needed for drawbridge (%02d, %02d)",
				    current_coord.x, current_coord.y);
			    yyerror(ebuf);
			}

			if ( (yyvsp[(7) - (7)].i) == D_ISOPEN )
			    tmpdb[ndb]->db_open = 1;
			else if ( (yyvsp[(7) - (7)].i) == D_CLOSED )
			    tmpdb[ndb]->db_open = 0;
			else
			    yyerror("A drawbridge can only be open or closed!");
			ndb++;
			if (ndb >= MAX_OF_TYPE) {
				yyerror("Too many drawbridges in mazepart!");
				ndb--;
			}
		   ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1086 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpwalk[nwalk] = New(walk);
			tmpwalk[nwalk]->x = current_coord.x;
			tmpwalk[nwalk]->y = current_coord.y;
			tmpwalk[nwalk]->dir = (yyvsp[(5) - (5)].i);
			nwalk++;
			if (nwalk >= MAX_OF_TYPE) {
				yyerror("Too many mazewalks in mazepart!");
				nwalk--;
			}
		  ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1100 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			wallify_map();
		  ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1106 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplad[nlad] = New(lad);
			tmplad[nlad]->x = current_coord.x;
			tmplad[nlad]->y = current_coord.y;
			tmplad[nlad]->up = (yyvsp[(5) - (5)].i);
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Ladder");
			nlad++;
			if (nlad >= MAX_OF_TYPE) {
				yyerror("Too many ladders in mazepart!");
				nlad--;
			}
		  ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1123 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpstair[nstair] = New(stair);
			tmpstair[nstair]->x = current_coord.x;
			tmpstair[nstair]->y = current_coord.y;
			tmpstair[nstair]->up = (yyvsp[(5) - (5)].i);
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Stairway");
			nstair++;
			if (nstair >= MAX_OF_TYPE) {
				yyerror("Too many stairs in room or mazepart!");
				nstair--;
			}
		  ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1140 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg] = New(lev_region);
			tmplreg[nlreg]->in_islev = (yyvsp[(3) - (3)].i);
			tmplreg[nlreg]->inarea.x1 = current_region.x1;
			tmplreg[nlreg]->inarea.y1 = current_region.y1;
			tmplreg[nlreg]->inarea.x2 = current_region.x2;
			tmplreg[nlreg]->inarea.y2 = current_region.y2;
		  ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1149 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg]->del_islev = (yyvsp[(6) - (8)].i);
			tmplreg[nlreg]->delarea.x1 = current_region.x1;
			tmplreg[nlreg]->delarea.y1 = current_region.y1;
			tmplreg[nlreg]->delarea.x2 = current_region.x2;
			tmplreg[nlreg]->delarea.y2 = current_region.y2;
			if((yyvsp[(8) - (8)].i))
			    tmplreg[nlreg]->rtype = LR_UPSTAIR;
			else
			    tmplreg[nlreg]->rtype = LR_DOWNSTAIR;
			tmplreg[nlreg]->rname.str = 0;
			nlreg++;
			if (nlreg >= MAX_OF_TYPE) {
				yyerror("Too many levregions in mazepart!");
				nlreg--;
			}
		  ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1169 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg] = New(lev_region);
			tmplreg[nlreg]->in_islev = (yyvsp[(3) - (3)].i);
			tmplreg[nlreg]->inarea.x1 = current_region.x1;
			tmplreg[nlreg]->inarea.y1 = current_region.y1;
			tmplreg[nlreg]->inarea.x2 = current_region.x2;
			tmplreg[nlreg]->inarea.y2 = current_region.y2;
		  ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1178 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg]->del_islev = (yyvsp[(6) - (8)].i);
			tmplreg[nlreg]->delarea.x1 = current_region.x1;
			tmplreg[nlreg]->delarea.y1 = current_region.y1;
			tmplreg[nlreg]->delarea.x2 = current_region.x2;
			tmplreg[nlreg]->delarea.y2 = current_region.y2;
			tmplreg[nlreg]->rtype = LR_PORTAL;
			tmplreg[nlreg]->rname.str = (yyvsp[(8) - (8)].map);
			nlreg++;
			if (nlreg >= MAX_OF_TYPE) {
				yyerror("Too many levregions in mazepart!");
				nlreg--;
			}
		  ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1195 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg] = New(lev_region);
			tmplreg[nlreg]->in_islev = (yyvsp[(3) - (3)].i);
			tmplreg[nlreg]->inarea.x1 = current_region.x1;
			tmplreg[nlreg]->inarea.y1 = current_region.y1;
			tmplreg[nlreg]->inarea.x2 = current_region.x2;
			tmplreg[nlreg]->inarea.y2 = current_region.y2;
		  ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1204 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg]->del_islev = (yyvsp[(6) - (6)].i);
			tmplreg[nlreg]->delarea.x1 = current_region.x1;
			tmplreg[nlreg]->delarea.y1 = current_region.y1;
			tmplreg[nlreg]->delarea.x2 = current_region.x2;
			tmplreg[nlreg]->delarea.y2 = current_region.y2;
		  ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1212 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			switch((yyvsp[(8) - (8)].i)) {
			case -1: tmplreg[nlreg]->rtype = LR_TELE; break;
			case 0: tmplreg[nlreg]->rtype = LR_DOWNTELE; break;
			case 1: tmplreg[nlreg]->rtype = LR_UPTELE; break;
			}
			tmplreg[nlreg]->rname.str = 0;
			nlreg++;
			if (nlreg >= MAX_OF_TYPE) {
				yyerror("Too many levregions in mazepart!");
				nlreg--;
			}
		  ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1228 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg] = New(lev_region);
			tmplreg[nlreg]->in_islev = (yyvsp[(3) - (3)].i);
			tmplreg[nlreg]->inarea.x1 = current_region.x1;
			tmplreg[nlreg]->inarea.y1 = current_region.y1;
			tmplreg[nlreg]->inarea.x2 = current_region.x2;
			tmplreg[nlreg]->inarea.y2 = current_region.y2;
		  ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1237 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmplreg[nlreg]->del_islev = (yyvsp[(6) - (6)].i);
			tmplreg[nlreg]->delarea.x1 = current_region.x1;
			tmplreg[nlreg]->delarea.y1 = current_region.y1;
			tmplreg[nlreg]->delarea.x2 = current_region.x2;
			tmplreg[nlreg]->delarea.y2 = current_region.y2;
			tmplreg[nlreg]->rtype = LR_BRANCH;
			tmplreg[nlreg]->rname.str = 0;
			nlreg++;
			if (nlreg >= MAX_OF_TYPE) {
				yyerror("Too many levregions in mazepart!");
				nlreg--;
			}
		  ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1254 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = -1;
		  ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1258 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = (yyvsp[(2) - (2)].i);
		  ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1264 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = 0;
		  ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1268 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
/* This series of if statements is a hack for MSC 5.1.  It seems that its
   tiny little brain cannot compile if these are all one big if statement. */
			if ((yyvsp[(3) - (10)].i) < 0 || (yyvsp[(3) - (10)].i) >= COLNO)
				yyerror("Region out of level range!");
			else if ((yyvsp[(5) - (10)].i) < 0 || (yyvsp[(5) - (10)].i) >= ROWNO)
				yyerror("Region out of level range!");
			else if ((yyvsp[(7) - (10)].i) < 0 || (yyvsp[(7) - (10)].i) >= COLNO)
				yyerror("Region out of level range!");
			else if ((yyvsp[(9) - (10)].i) < 0 || (yyvsp[(9) - (10)].i) >= ROWNO)
				yyerror("Region out of level range!");
			current_region.x1 = (yyvsp[(3) - (10)].i);
			current_region.y1 = (yyvsp[(5) - (10)].i);
			current_region.x2 = (yyvsp[(7) - (10)].i);
			current_region.y2 = (yyvsp[(9) - (10)].i);
			(yyval.i) = 1;
		  ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1286 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
            current_region.x1 = current_region.x2 = COLNO;
            current_region.y1 = current_region.y2 = ROWNO;
            (yyval.i) = 1;
          ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1294 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpfountain[nfountain] = New(fountain);
			tmpfountain[nfountain]->x = current_coord.x;
			tmpfountain[nfountain]->y = current_coord.y;
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Fountain");
			nfountain++;
			if (nfountain >= MAX_OF_TYPE) {
			    yyerror("Too many fountains in room or mazepart!");
			    nfountain--;
			}
		  ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1310 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpsink[nsink] = New(sink);
			tmpsink[nsink]->x = current_coord.x;
			tmpsink[nsink]->y = current_coord.y;
			nsink++;
			if (nsink >= MAX_OF_TYPE) {
				yyerror("Too many sinks in room!");
				nsink--;
			}
		  ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1323 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmppool[npool] = New(pool);
			tmppool[npool]->x = current_coord.x;
			tmppool[npool]->y = current_coord.y;
			npool++;
			if (npool >= MAX_OF_TYPE) {
				yyerror("Too many pools in room!");
				npool--;
			}
		  ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1336 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpdig[ndig] = New(digpos);
			tmpdig[ndig]->x1 = current_region.x1;
			tmpdig[ndig]->y1 = current_region.y1;
			tmpdig[ndig]->x2 = current_region.x2;
			tmpdig[ndig]->y2 = current_region.y2;
			ndig++;
			if (ndig >= MAX_OF_TYPE) {
				yyerror("Too many diggables in mazepart!");
				ndig--;
			}
		  ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1351 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmppass[npass] = New(digpos);
			tmppass[npass]->x1 = current_region.x1;
			tmppass[npass]->y1 = current_region.y1;
			tmppass[npass]->x2 = current_region.x2;
			tmppass[npass]->y2 = current_region.y2;
			npass++;
			if (npass >= 32) {
				yyerror("Too many passwalls in mazepart!");
				npass--;
			}
		  ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1366 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpreg[nreg] = New(region);
			tmpreg[nreg]->x1 = current_region.x1;
			tmpreg[nreg]->y1 = current_region.y1;
			tmpreg[nreg]->x2 = current_region.x2;
			tmpreg[nreg]->y2 = current_region.y2;
			tmpreg[nreg]->rlit = (yyvsp[(5) - (8)].i);
			tmpreg[nreg]->rtype = (yyvsp[(7) - (8)].i);
			if((yyvsp[(8) - (8)].i) & 1) tmpreg[nreg]->rtype += MAXRTYPE+1;
			tmpreg[nreg]->rirreg = (((yyvsp[(8) - (8)].i) & 2) != 0);
			if(current_region.x1 > current_region.x2 ||
			   current_region.y1 > current_region.y2)
			   yyerror("Region start > end!");
			if(tmpreg[nreg]->rtype == VAULT &&
			   (tmpreg[nreg]->rirreg ||
			    (tmpreg[nreg]->x2 - tmpreg[nreg]->x1 != 1) ||
			    (tmpreg[nreg]->y2 - tmpreg[nreg]->y1 != 1)))
				yyerror("Vaults must be exactly 2x2!");
			if(want_warnings && !tmpreg[nreg]->rirreg &&
			   current_region.x1 > 0 && current_region.y1 > 0 &&
			   current_region.x2 < (int)max_x_map &&
			   current_region.y2 < (int)max_y_map) {
			    /* check for walls in the room */
			    char ebuf[60];
			    int x, y, nrock = 0;

			    for(y=current_region.y1; y<=current_region.y2; y++)
				for(x=current_region.x1;
				    x<=current_region.x2; x++)
				    if(IS_ROCK(tmpmap[y][x]) ||
				       IS_DOOR(tmpmap[y][x])) nrock++;
			    if(nrock) {
				snprintf(ebuf, SIZE(ebuf),
					"Rock in room (%02d,%02d,%02d,%02d)?!",
					current_region.x1, current_region.y1,
					current_region.x2, current_region.y2);
				yywarning(ebuf);
			    }
			    if (
		!IS_ROCK(tmpmap[current_region.y1-1][current_region.x1-1]) ||
		!IS_ROCK(tmpmap[current_region.y2+1][current_region.x1-1]) ||
		!IS_ROCK(tmpmap[current_region.y1-1][current_region.x2+1]) ||
		!IS_ROCK(tmpmap[current_region.y2+1][current_region.x2+1])) {
				snprintf(ebuf, SIZE(ebuf),
				"NonRock edge in room (%02d,%02d,%02d,%02d)?!",
					current_region.x1, current_region.y1,
					current_region.x2, current_region.y2);
				yywarning(ebuf);
			    }
			} else if(tmpreg[nreg]->rirreg &&
		!IS_ROOM(tmpmap[current_region.y1][current_region.x1])) {
			    char ebuf[60];
			    snprintf(ebuf, SIZE(ebuf),
				    "Rock in irregular room (%02d,%02d)?!",
				    current_region.x1, current_region.y1);
			    yyerror(ebuf);
			}
			nreg++;
			if (nreg >= MAX_OF_TYPE) {
				yyerror("Too many regions in mazepart!");
				nreg--;
			}
		  ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1432 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpaltar[naltar] = New(altar);
			tmpaltar[naltar]->x = current_coord.x;
			tmpaltar[naltar]->y = current_coord.y;
			tmpaltar[naltar]->align = (yyvsp[(5) - (7)].i);
			tmpaltar[naltar]->shrine = (yyvsp[(7) - (7)].i);
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Altar");
			naltar++;
			if (naltar >= MAX_OF_TYPE) {
				yyerror("Too many altars in room or mazepart!");
				naltar--;
			}
		  ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1450 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpgold[ngold] = New(gold);
			tmpgold[ngold]->x = current_coord.x;
			tmpgold[ngold]->y = current_coord.y;
			tmpgold[ngold]->amount = (yyvsp[(3) - (5)].i);
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Gold");
			ngold++;
			if (ngold >= MAX_OF_TYPE) {
				yyerror("Too many golds in room or mazepart!");
				ngold--;
			}
		  ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1467 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			tmpengraving[nengraving] = New(engraving);
			tmpengraving[nengraving]->x = current_coord.x;
			tmpengraving[nengraving]->y = current_coord.y;
			tmpengraving[nengraving]->engr.str = (yyvsp[(7) - (7)].map);
			tmpengraving[nengraving]->etype = (yyvsp[(5) - (7)].i);
			if (!in_room)
			    check_coord(current_coord.x, current_coord.y,
					"Engraving");
			nengraving++;
			if (nengraving >= MAX_OF_TYPE) {
			    yyerror("Too many engravings in room or mazepart!");
			    nengraving--;
			}
		  ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1486 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = - MAX_REGISTERS - 1;
		  ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1494 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = - MAX_REGISTERS - 1;
		  ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1502 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.map) = NULL;
		  ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1509 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.map) = NULL;
		  ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1515 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			int token = get_trap_type((yyvsp[(1) - (1)].map));
			if (token == ERR)
				yyerror("Unknown trap type!");
			(yyval.i) = token;
			Free((yyvsp[(1) - (1)].map));
		  ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1526 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			int token = get_room_type((yyvsp[(1) - (1)].map));
			if (token == ERR) {
				yywarning("Unknown room type!  Making ordinary room...");
				(yyval.i) = OROOM;
			} else
				(yyval.i) = token;
			Free((yyvsp[(1) - (1)].map));
		  ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1539 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = 0;
		  ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1543 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = (yyvsp[(2) - (2)].i);
		  ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1547 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = (yyvsp[(2) - (4)].i) + ((yyvsp[(4) - (4)].i) << 1);
		  ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1555 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			current_coord.x = current_coord.y = -MAX_REGISTERS-1;
		  ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1571 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = - MAX_REGISTERS - 1;
		  ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1581 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ( (yyvsp[(3) - (4)].i) >= MAX_REGISTERS )
				yyerror("Register Index overflow!");
			else
				current_coord.x = current_coord.y = - (yyvsp[(3) - (4)].i) - 1;
		  ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1590 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ( (yyvsp[(3) - (4)].i) >= MAX_REGISTERS )
				yyerror("Register Index overflow!");
			else
				(yyval.i) = - (yyvsp[(3) - (4)].i) - 1;
		  ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1599 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ( (yyvsp[(3) - (4)].i) >= MAX_REGISTERS )
				yyerror("Register Index overflow!");
			else
				(yyval.i) = - (yyvsp[(3) - (4)].i) - 1;
		  ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1608 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ( (yyvsp[(3) - (4)].i) >= 3 )
				yyerror("Register Index overflow!");
			else
				(yyval.i) = - (yyvsp[(3) - (4)].i) - 1;
		  ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1620 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (check_monster_char((char) (yyvsp[(1) - (1)].i)))
				(yyval.i) = (yyvsp[(1) - (1)].i) ;
			else {
				yyerror("Unknown monster class!");
				(yyval.i) = ERR;
			}
		  ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1631 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			char c = (yyvsp[(1) - (1)].i);
			if (check_object_char(c))
				(yyval.i) = c;
			else {
				yyerror("Unknown char class!");
				(yyval.i) = ERR;
			}
		  ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1650 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			(yyval.i) = 100;	/* default is 100% */
		  ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1654 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if ((yyvsp[(1) - (1)].i) <= 0 || (yyvsp[(1) - (1)].i) > 100)
			    yyerror("Expected percentile chance.");
			(yyval.i) = (yyvsp[(1) - (1)].i);
		  ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1666 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
			if (!in_room && !init_lev.init_present &&
			    ((yyvsp[(2) - (5)].i) < 0 || (yyvsp[(2) - (5)].i) > (int)max_x_map ||
			     (yyvsp[(4) - (5)].i) < 0 || (yyvsp[(4) - (5)].i) > (int)max_y_map))
			    yyerror("Coordinates out of map range!");
			current_coord.x = (yyvsp[(2) - (5)].i);
			current_coord.y = (yyvsp[(4) - (5)].i);
		  ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1677 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"
    {
/* This series of if statements is a hack for MSC 5.1.  It seems that its
   tiny little brain cannot compile if these are all one big if statement. */
			if ((yyvsp[(2) - (9)].i) < 0 || (yyvsp[(2) - (9)].i) > (int)max_x_map)
				yyerror("Region out of map range!");
			else if ((yyvsp[(4) - (9)].i) < 0 || (yyvsp[(4) - (9)].i) > (int)max_y_map)
				yyerror("Region out of map range!");
			else if ((yyvsp[(6) - (9)].i) < 0 || (yyvsp[(6) - (9)].i) > (int)max_x_map)
				yyerror("Region out of map range!");
			else if ((yyvsp[(8) - (9)].i) < 0 || (yyvsp[(8) - (9)].i) > (int)max_y_map)
				yyerror("Region out of map range!");
			current_region.x1 = (yyvsp[(2) - (9)].i);
			current_region.y1 = (yyvsp[(4) - (9)].i);
			current_region.x2 = (yyvsp[(6) - (9)].i);
			current_region.y2 = (yyvsp[(8) - (9)].i);
		  ;}
    break;



/* Line 1455 of yacc.c  */
#line 3818 "/home/nathan/git/working-fourk/build/libnethack/util/lev_comp.y/lev_comp.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1695 "/home/nathan/git/working-fourk/libnethack/util/lev_comp.y"


/*lev_comp.y*/



